<?php
/**
 * @version 1.5 stable $Id: flexisyspro.php 1764 2013-09-16 08:00:21Z ggppdk $
 * @plugin 1.1
 * @package Joomla
 * @subpackage FLEXIcontent
 * @copyright (C) 2009 Emmanuel Danan - www.vistamedia.fr
 * @license GNU/GPL v2
 * 
 * FLEXIcontent is a derivative work of the excellent QuickFAQ component
 * @copyright (C) 2008 Christoph Lukes
 * see www.schlu.net for more information
 *
 * FLEXIcontent is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );
if (!defined('DS'))  define('DS',DIRECTORY_SEPARATOR);
require_once (JPATH_ADMINISTRATOR.DS.'components'.DS.'com_flexicontent'.DS.'defineconstants.php');

/**
 * Example system plugin
 */
class plgSystemFlexisyspro extends JPlugin
{
	/**
	 * Constructor
	 */
	function plgSystemFlexisyspro( &$subject, $config )
	{
		parent::__construct( $subject, $config );
		$extension_name = 'com_flexicontent';
		//JPlugin::loadLanguage($extension_name, JPATH_SITE);
		JFactory::getLanguage()->load($extension_name, JPATH_SITE, 'en-GB'	, true);
		JFactory::getLanguage()->load($extension_name, JPATH_SITE, null		, true);
	}
	
	
	/**
	 * Joomla initialized, but component has not been decided yet, this is good place to some actions regardless of component
	 * OR to make early redirections OR to alter variables used to do routing (deciding the component that will be executed)
	 *
	 * @access public
	 * @return boolean
	 */
	/*function onAfterInitialise()
	{
	}*/
	
	
	/**
	 * Joomla initialized, and component has been decided, and component's optional request (URL) variables have been set (e.g. those set via the menu item)
	 * this is good place to make redirections needing the component's optional request variables, and to calculate data that are globally needed
	 *
	 * @access public
	 * @return boolean
	 */
	/*function onAfterRoute()
	{
	}*/
	
	
	/**
	 * After component has created its output, this is good place to make global replacements
	 *
	 * @access public
	 * @return boolean
	 */
	public function onAfterRender()
	{
		if ($this->params->get('replace_fields', 1) || $this->params->get('replace_items', 1)) $this->doReplacementsInResponse(1);
		
		//$html = JResponse::getBody();
		
		//$html = preg_replace('#<script([^>](?!src))*type="text/javascript"([^>](?!src))*>#', "\n".'$0'."\n".'// <![CDATA['."\n", $html);
		//$html = preg_replace('#([^\s>]+)([\s]*)</script>#', "$1$2\n".'// ]]>'."\n".'</script>', $html);
		
		// 2nd replacement above is slow, instead will add this everywhere even to scirpt that are file links
		//$html = preg_replace('#<script([^>])*>#', "\n".'$0'."\n".'// <![CDATA['."\n", $html);
		//$html = str_replace('</script>', "\n".'// ]]>'."\n".'</script>', $html);
		
		//JResponse::setBody($html);
		
		return true;
	}
	
	
	/**
    * Utility Function: Implements field AND ITEM replacements, allowing 'rendered display' of any field(s) to be placed anywhere inside the joomla response HTML, formats are:
    * {flexi_FIELD:%fieldname%  item:%item_id%  method:%method_name%}
	  *     e.g. {flexi_FIELD:field29  item:117}
  	*     e.g. {flexi_FIELD:field29  item:117  method:display}
  	*
    * {flexi_FIELD:%fieldid%   item:[%item_id% | current]   method:%method_name%}
    *       e.g. {flexi_FIELD:29  item:117      method:display}
    *       e.g. {flexi_FIELD:29  item:current  method:display}
    *
    * {flexi_ITEM:%itemid%  ilayout:%template_name%}
    *       e.g. {flexi_ITEM:4444  ilayout:mydefault}
    *
    * {flexi_ITEM:profile  user:%user_id%  ilayout:%template_name%  }
    *       e.g. {flexi_ITEM:profile  user:137  ilayout:mydefault}    // THIS IS user profile item of user no 137
    *
    * {flexi_ITEM:profile  author_of:[%item_id% | current]  ilayout:%template_name%  }
    *       e.g. {flexi_ITEM:profile  author_of:441  ilayout:mydefault}    // THIS IS user profile item of user that is authored item no 441
    *       e.g. {flexi_ITEM:profile  author_of:current}           // THIS IS user profile item of user that is authored currently viewed item (current view should be ITEM VIEW)
    *
    * @access public
    * @return void
    */
	function doReplacementsInResponse($replace=1)
	{
		// **************************
		// EXCLUDE some views / cases
		// **************************
		
		// Only execute in SITE environment
		$app = JFactory::getApplication();
		if ($app->getName() != 'site' ) return;
		
		// Exclude non-html views
		$document = JFactory::getDocument();
		$docType = $document->getType();
		if ($docType != 'html') return;
		
		// Get URL variables
		$option = JRequest::getCMD('option');
		$view = JRequest::getCMD('view');
		$task = JRequest::getCMD('task');
		$db = JFactory::getDBO();
		
		// Exclude item edit form
		// Need to improve this to allow replacing in module position when item form is active
		$isEditForm = ( ($option=='com_content' && $view=='form') || ($option=='com_flexicontent' && $view==FLEXI_ITEMVIEW && $task) );
		if ( $isEditForm ) return;
		
		$fparams = JComponentHelper::getParams('com_flexicontent');
		$print_logging_info = $fparams->get('print_logging_info');
		if ($print_logging_info) { global $fc_run_times; $start_microtime = microtime(true); }
		
		
		// FULL TEXTs of found replacements
		static $field_full_texts, $item_full_texts;
		// FULL TEXTs of PROPERTIES that customize the replacements
		static $field_prop_lists, $item_prop_lists;
		
		// IDs of FIELDs or of ITEMs to be replaced
		static $field_names, $item_ids;
		
		// Replacement properties for FIELDs / ITEMs
		static $field_itemids, $field_methods;
		static $item_layouts;
		
		// Rendered FIELDs / ITEMs HTML to be used for replacing the matched replacements
		static $field_html, $item_html;
		
		
		
		// ***************************************************************************
		// SECOND call: Replace the replacement code with the rendered field's display
		// ***************************************************************************
		if ($replace)
		{
			
			// *****************************
			// Replace fields in page's HTML
			// *****************************
			if( !empty($field_full_texts) && $this->params->get('replace_fields', 1) )
			{
				$html = JResponse::getBody();
				foreach ($field_full_texts as $i => $full_text) {
					$item_id = $field_itemids[$i];
					$field_name = $field_names[$i];
					$method = isset($field_methods[$i]) ? $field_methods[$i] : 'display';
					if ( isset($field_html[$item_id][$field_name][$method]) ) {
						$html = str_replace( $full_text,  $field_html[$item_id][$field_name][$method],  $html);
					} else {
						if ($this->params->get('debug_replacements', 1))
							$html = str_replace( $full_text,  'REPLACEMENT NOT FOUND: <pre>'. $full_text .'</pre>',  $html);
						else
							$html = str_replace( $full_text,  '',  $html);
					}
				}
				JResponse::setBody($html);
				
				if ($print_logging_info) $fc_run_times['global_replacements'] += round(1000000 * 10 * (microtime(true) - $start_microtime)) / 10;
			}
			
			// ****************************
			// Replace items in page's HTML
			// ****************************
			if( !empty($item_full_texts) && $this->params->get('replace_items', 1) )
			{
				$html = JResponse::getBody();
				foreach ($item_full_texts as $i => $full_text) {
					$item_id = $item_ids[$i];
					$item_layout = $item_layouts[$i];
					if ( isset($item_html[$item_id][$item_layout]) ) {
						$html = str_replace( $full_text,  $item_html[$item_id][$item_layout],  $html);
					} else {
						if ($this->params->get('debug_replacements', 1))
							$html = str_replace( $full_text,  'REPLACEMENT NOT FOUND: <pre>'. $full_text .'</pre>',  $html);
						else
							$html = str_replace( $full_text,  '',  $html);
					}
				}
				JResponse::setBody($html);
				
				if ($print_logging_info) $fc_run_times['global_replacements'] += round(1000000 * 10 * (microtime(true) - $start_microtime)) / 10;
			}
			
			return;
		}
		
		
		
		// ********************************************************************************************************************
		// FIRST call: Find replacements and render the fields (must be 2 step to allow adding to the CSS/JS files to the head)
		// ********************************************************************************************************************
		
		// **************************
		// Get buffered document HTML
		// **************************
		error_reporting(E_ALL);
		ini_set('display_errors', 1);
		
		$buffer = $document->getBuffer();
		$html = '';
		if (isset($buffer['modules'])) foreach($buffer['modules'] as &$str) {
			/*if ($isEditForm) {
				if (is_array($str)) foreach($str as &$_str) {
					$_str = str_ireplace("flexi_field:", "flexi_field_MODULE:", $_str);
					$_str = str_ireplace("flexi_item:", "flexi_item_MODULE:", $_str);
				} else {
					$str = str_ireplace("flexi_field:", "flexi_field_MODULE:", $str);
					$str = str_ireplace("flexi_item:", "flexi_item_MODULE:", $str);
				}
				unset($_str);  // unset loop reference variable
			}*/
			$html .= is_array($str) ? implode($str, "") : $str;
		}
		unset($str);  // unset loop reference variable
		
		if (!$isEditForm && isset($buffer['component'])) foreach($buffer['component'] as &$str) {
			$html .= is_array($str) ? implode($str, "") : $str;
		}
		unset($str);  // unset loop reference variable
		
		//$document->setBuffer($buffer);
		
		
		// ********************************************************
		// Create regular expresion for matching field replacements
		// and parse the HTML body to locate any replacements
		// ********************************************************
		//$regex_full = '/{flexi_(field|item)'.($isEditForm ? '_MODULE' : '').':'
		$regex_full = '/{flexi_(field|item):'
				.'\s*'
				.'([^\s]+)'  // field name or field id or item id
				.'\s+'
			 .'([^}]+)'    // other properties ...
			 .'}/ui';
		$res  = preg_match_all($regex_full, $html, $matches);
		if (!$res) return true;
		//echo "<pre>" . print_r($matches,true) . "</pre>";
		
		// Do some cleaning of the matched HTML
		foreach ($matches as $k => $match_arr) {
			if ($k==0) continue;
			foreach ($match_arr as $i => $match)
				$matches[$k][$i] = trim(str_replace('&nbsp;','',$match));
		}
		
		
		// *********************************************************************************
		// Parse properties of the fields to be rendered like: item id  -and- display method
		// *********************************************************************************
		$full_texts    = $matches[0];
		$replace_types = $matches[1];
		$target_ids    = $matches[2];
		$target_data   = $matches[3];
		
		$n = 0;
		$_uniq_fltxts_ = array();
		$field_prop_lists = array();
		$item_prop_lists  = array();
		$field_names = array();
		foreach($full_texts as $i => $fltxt)
		{
			// Create only 1 set of properties for every unique full text
			if ( isset($_uniq_fltxts_[$fltxt]) ) continue;
			$_uniq_fltxts_[$fltxt] = 1;
			
			$replace_type = $replace_types[$i];
			if ( !strcasecmp($replace_type,'field') ) {
				$field_full_texts[$n] = $full_texts[$i];
				$field_names[$n]      = $target_ids[$i];
				$field_prop_lists[$n] = $target_data[$i];
				$n++;
			} else if ( !strcasecmp($replace_type,'item') ) {
				$item_full_texts[$n] = $full_texts[$i];
				$item_ids[$n]        = $target_ids[$i];
				$item_prop_lists[$n] = $target_data[$i];
				$n++;
			}
		}
		/*echo "<pre>" . print_r($field_full_texts,true) . "</pre>";
		echo "<pre>" . print_r($field_names,true) . "</pre>";
		echo "<pre>" . print_r($field_prop_lists,true) . "</pre>";
		
		echo "<pre>" . print_r($item_full_texts,true) . "</pre>";
		echo "<pre>" . print_r($item_ids,true) . "</pre>";
		echo "<pre>" . print_r($item_prop_lists,true) . "</pre>";*/
		
		
		if ( count($field_full_texts) || count($item_full_texts) )
		{
			$filter_input = new JFilterInput();
			$regex_properties = '/\s*'
				.'([^\s]+)'    // property name
				.'\s*:\s*'
				.'([^\s}]+)\s*'  // property value
			 	.'/ui';
			
			
			// PARSE properties for FIELD REPLACEMENTS
			if (count($field_prop_lists))
			{
				$field_itemids = array();
				$field_methods = array();
				foreach ($field_prop_lists as $p => $property_list)
				{
					preg_match_all($regex_properties, $property_list, $property_matches, PREG_SET_ORDER);
					foreach ($property_matches as $pm)
					{
						switch ( $pm[1] ) {
							case 'item':
								if ($pm[2]!='current') {
									$field_itemids[$p] = (int)$pm[2];
								} else {
									if ($view=='item')
										$field_itemids[$p] = JRequest::getInt('id');
									else if ($view=='category')
										$field_itemids[$p] = JRequest::getInt('authorid');
									else
										$field_itemids[$p] = 0;
								}
								break;
							case 'method':
								$field_methods[$p] = $filter_input->clean( htmlspecialchars_decode($pm[2]), 'CMD');
								break;
						}
					}
				}
			}
			
			
			// PARSE properties for ITEM REPLACEMENTS
			if (count($item_prop_lists))
			{
				$item_layouts = array();
				foreach ($item_prop_lists as $p => $property_list)
				{
					$item_layouts[$p] = '';
					preg_match_all($regex_properties, $property_list, $property_matches, PREG_SET_ORDER);
					foreach ($property_matches as $pm)
					{
						switch ( $pm[1] ) {
							case 'user':
								$item_ids[$p] = 0;
								$query = "SELECT author_basicparams, author_catparams"
									." FROM #__flexicontent_authors_ext WHERE user_id = " . (int)$pm[2];
								$db->setQuery($query);
								$author_extdata = $db->loadObject();
								if ($author_extdata) {
									$_author_basicreg = FLEXI_J16GE ? new JRegistry($author_extdata->author_basicparams) : new JParameter($author_extdata->author_basicparams);
									$item_ids[$p] = $_author_basicreg->get('authordescr_itemid', 0);
								}
								break;
							case 'author_of':
								$item_ids[$p] = 0;
								$_item_id = $pm[2]=='current' ? JRequest::getInt('id') : (int)$pm[2];
								$query = "SELECT author_basicparams, author_catparams"
									." FROM #__flexicontent_authors_ext AS uext"
									." JOIN #__content AS i ON uext.user_id=i.created_by"
									." WHERE i.id = " . $_item_id;
								$db->setQuery($query);
								$author_extdata = $db->loadObject();
								if ($author_extdata) {
									$_author_basicreg = FLEXI_J16GE ? new JRegistry($author_extdata->author_basicparams) : new JParameter($author_extdata->author_basicparams);
									$item_ids[$p] = $_author_basicreg->get('authordescr_itemid', 0);
								}
								break;
							case 'ilayout':
								$item_layouts[$p] = $filter_input->clean( htmlspecialchars_decode($pm[2]), 'CMD');
								break;
						}
					}
				}
				/*echo __FUNCTION__."():"
					."<br/>\n fields: "  . print_r($field_names, true)
					."<br/>\n items: "   . print_r($field_itemids, true)
					."<br/>\n methods: " . print_r($field_methods,true)
					."";*/
			}
			
			
			// ****************************************************
			// Check if field ids were given instead of field names
			// and retrieve the field names via a single query
			// ****************************************************
			$field_ids = array();
			foreach ($field_names as $field_name) {
				if ( $field_name == (int)$field_name ) $field_ids[(int)$field_name] = 1;
			}
			$field_ids = array_keys($field_ids);
			
			if ( count($field_ids) )
			{
				$query = 'SELECT name, id FROM #__flexicontent_fields WHERE id IN (' . implode($field_ids, ', ') .')';
				$db->setQuery($query);
				$field_data = $db->loadObjectList('id');
				
				// Set the field names, replacing the field ids
				foreach ($field_names as $i => $field_name) {
					$field_id   = (int)$field_name;
					$field_name = @$field_data[$field_id]->name;
					$field_names[$i] = $field_name  ?  $field_name  :  $field_names[$i];
				}
			}
			
			
			// **************************************************************************************
			// Despite eliminating same full-texts above, some replacements may still render the same
			// TRIPLET: (itemid, fieldname, displaymethod), so create a unique set for every triplet
			// **************************************************************************************
			$unique_field_replacements = array();
			foreach($field_names as $i => $fieldname) {
				if ( !isset($field_itemids[$i]) ) continue;
				$field_itemid = $field_itemids[$i];
				$field_method = isset($field_methods[$i]) ? $field_methods[$i] : 'display';
				$unique_field_replacements[$field_itemid] [$fieldname] [$field_method] = 1;
			}
			//echo "<pre>"; print_r($unique_field_replacements); echo "</pre>";
			
			$_field_itemids = array();
			$_field_names   = array();
			$_field_methods = array();
			foreach($unique_field_replacements as $itemid => $_i) {
				foreach($_i as $fieldname => $_f) {
					foreach($_f as $displaymethod => $_m) {
						$_field_itemids[] = $itemid;
						$_field_names[]   = $fieldname;
						$_field_methods[] = $displaymethod;
					}
				}
			}
			//echo "<pre>" . print_r($_field_itemids,true) . "</pre>";
			//echo "<pre>" . print_r($_field_names,true) . "</pre>";
			//echo "<pre>" . print_r($_field_methods,true) . "</pre>";
			
			
			// ********************************
			// Render the display of the fields
			// ********************************
			if( !empty($field_full_texts) && $this->params->get('replace_fields', 1) ) {
				$field_html = FlexicontentFields::renderFields( $item_per_field=true, $_field_itemids, $_field_names, $view=FLEXI_ITEMVIEW, $_field_methods, $cfparams=array() );
			}
			
			
			// *******************************
			// Render the display of the items
			// *******************************
			if( !empty($item_full_texts) && $this->params->get('replace_items', 1) ) {
				$fc_html_obj = new flexicontent_html();
				foreach ($item_ids as $i => $item_id) {
					if (!$item_id) continue;
					$ilayout = $item_layouts[$i];
					$item_html[$item_id][$ilayout] = $fc_html_obj->renderItem($item_id, FLEXI_ITEMVIEW, $ilayout);
				}
			}
			
			if ($print_logging_info) $fc_run_times['global_replacements'] = round(1000000 * 10 * (microtime(true) - $start_microtime)) / 10;
		}
	}
	
	
	/**
	 * Before header HTML is created but after modules and component HTML has been created, this is a good place to call any code that needs to add CSS/JS files
	 *
	 * @access public
	 * @return boolean
	 */
	public function onBeforeCompileHead() {
		if ($this->params->get('replace_fields', 1) || $this->params->get('replace_items', 1)) $this->doReplacementsInResponse(0);
	}
}